#include <imsls.h>
#include <math.h>

static void  sgarch (int p, int q, int m, float x[],
                float y[], float z[], float y0[], float sigma[]);
#define	M	1000
#define	N	(P + Q + 1)
#define	P	2
#define	Q	1

int main ()
{
    int        n, p, q, m;
    float      a, aic, wk1[M + 1000], wk2[M + 1000],
                wk3[M + 1000], x[N], xguess[N],  y[M];
    float      *result;

    imsls_random_seed_set (182198625);
    m = M;
    p = P;
    q = Q;
    n = p+q+1;
    x[0] = 1.3;
    x[1] = .2;
    x[2] = .3;
    x[3] = .4;
    xguess[0] = 1.0;
    xguess[1] = .1;
    xguess[2] = .2;
    xguess[3] = .3;
    sgarch (p, q, m, x, y, wk1, wk2, wk3);
    result = imsls_f_garch(p, q, m, y, xguess,
			IMSLS_A, &a,
			IMSLS_AIC, &aic, 
			0);
    printf("Sigma estimate is\t%11.4f\n", result[0]);
    printf("ARCH(1) estimate is\t%11.4f\n", result[1]);
    printf("GARCH(1) estimate is\t%11.4f\n", result[2]);
    printf("GARCH(2) estimate is\t%11.4f\n", result[3]);
    printf("\nLog-likelihood function value is\t%11.4f\n", a);
    printf("Akaike Information Criterion value is\t%11.4f\n", aic);
    return;
}

static void sgarch (int p, int q, int m, float x[],
                float y[], float z[], float y0[], float sigma[])
{
    int        i, j, l;
    float      s1, s2, s3;

   imsls_f_random_normal ( m + 1000, IMSLS_RETURN_USER, z, 0);

    l = imsls_i_max (p, q);
    l = imsls_i_max (l, 1);
    for (i = 0; i < l; i++) y0[i] = z[i] * x[0];

    /* COMPUTE THE INITIAL VALUE OF SIGMA */
    s3 = 0.0;
    if (imsls_i_max (p, q) >= 1) {
	for (i = 1; i < (p + q + 1); i++) s3 += x[i];
    }
    for (i = 0; i < l; i++) sigma[i] = x[0] / (1.0 - s3);

    for (i = l; i < (m + 1000); i++) {
	s1 = 0.0;
	s2 = 0.0;
	if (q >= 1) {
	    for (j = 0; j < q; j++)
	      s1 += x[j + 1] * y0[i - j - 1] * y0[i - j - 1];
	}
	if (p >= 1) {
	    for (j = 0; j < p; j++) 
	      s2 += x[q + 1 + j] * sigma[i - j - 1];
	}
	sigma[i] = x[0] + s1 + s2;
	y0[i] = z[i] * sqrt (sigma[i]);
    }
    /*
     * DISCARD THE FIRST 1000 SIMULATED OBSERVATIONS
     */
    for (i = 0; i < m; i++) y[i] = y0[1000 + i];
    return;
}				/* end of function */
